<?php
class WtestController extends WadminController {

	public function listadoAction(){
		$ap = new AppListadoResultado();
		$ap->setClass('servicio');
		print_r($ap);
		die();
	}
	
	public function fechaAction(){
		
		$fecha = '13/7/2016';
		echo 'Pasar de fecha a mes';
		print_r(Tool::fechaSeparar($fecha));
		die();
	}
	
	public function liquidacionAction(){
		
		$params = AppObjeto::testGetParams();

		$params['comercial'] = '0588000'; // PADRE
		$params['comercial'] = '0588001'; // HIJO
		$params['dia'] = '1';
		$params['mes'] = '7';
		$params['año'] = '2016';
		print_r($params);
		$liquidaciones = Liquidacion::lst_calculateByComisionista($params);
		print_r($liquidaciones);
		echo ' ### La liquidación del 1/7/2016 para 0588000 es %15 - 13,3485 de 88.99';
		die();
	}
	
	public function liquidacionmesesAction(){

		$params = AppObjeto::testGetParams();
		$params['comercial'] = '0588000'; // PADRE
		//$params['comercial'] = '0060000'; // ROQUE
		
		$liquidaciones = Liquidacion::lst_calculateMonthByComisionista($params);
		die();
	}
	
	public function comercialpotencialAction(){

		echo 'COMERCIAL DE POTENCIAL<br><br>';
		
		$codigo_potencial = '0064286';
		$codigo_origen_sin_comisionista = '2';
		$codigo_origen_con_comisionista = '186';
		$codigo_afiliado_con_padre = '0064907';
		$codigo_afiliado_sin_padre = '0064906';
		$codigo_afiliado_vacio = '';
	
		$potencial = new Potencial($codigo_potencial);
		
		$potencial->asignarComercial($codigo_origen_sin_comisionista, $codigo_afiliado_vacio);
		if ($potencial->getComercial() == '') 
			echo 'OK'; else '-<span style="background-color:#F00">---- KO</span>';
		echo ' ### Codigo Origen Sin Comisionista - Sin afiliado';
		echo '<br>';
		
		$potencial->asignarComercial($codigo_origen_sin_comisionista, $codigo_afiliado_con_padre);
		if ($potencial->getComercial() == $codigo_afiliado_con_padre)
			echo 'OK'; else '-<span style="background-color:#F00">---- KO</span>';
		echo ' ### Codigo Origen Sin Comisionista - Afiliado con padre';
		echo '<br>';
		
		$potencial->asignarComercial($codigo_origen_sin_comisionista, $codigo_afiliado_sin_padre);
		if ($potencial->getComercial() == $codigo_afiliado_sin_padre)
			echo 'OK'; else '-<span style="background-color:#F00">---- KO</span>';
		echo ' ### Codigo Origen Sin Comisionista - Afiliado sin padre';
		echo '<br>';

		$potencial->asignarComercial($codigo_origen_con_comisionista, $codigo_afiliado_vacio);
		$origen = new Origen($codigo_origen_con_comisionista);
		if ($potencial->getComercial() == $origen->getCodigoComisionista())
			echo 'OK'; else '-<span style="background-color:#F00">---- KO</span>';
		echo ' ### Codigo Origen Con Comisionista - Sin afiliado';
		echo '<br>';
		
		$potencial->asignarComercial($codigo_origen_sin_comisionista, $codigo_afiliado_con_padre);
		if ($potencial->getComercial() == $codigo_afiliado_con_padre)
			echo 'OK'; else '-<span style="background-color:#F00">---- KO</span>';
		echo ' ### Codigo Origen Con Comisionista - Afiliado con padre';
		echo '<br>';
		
		$potencial->asignarComercial($codigo_origen_sin_comisionista, $codigo_afiliado_sin_padre);
		if ($potencial->getComercial() == $codigo_afiliado_sin_padre)
			echo 'OK'; else '-<span style="background-color:#F00">---- KO</span>';
		echo ' ### Codigo Origen Con Comisionista - Afiliado sin padre';
		echo '<br>';
		
		
		die();
	}
	
	public function comisionistasAction(){
		
		$codigo_potencial_sin_comercial = '0056960'; // PRESUPUESTO 2
		$codigo_potencial_sin_autocompra_con_comisionista_sin_rapel = '0064286'; // VCC CLIENTE COMISIONISTA PADRE
		$codigo_potencial_sin_autocompra_con_comisionista_con_rapel = '0060874'; // VCC CLIENTE COMISIONISTA PADRE
		$codigo_potencial_con_autocompra_con_comisionista_sin_rapel = '0064922'; // VCC GRUPO AGENCIAS		
		$codigo_potencial_con_autocompra_con_comisionista_con_rapel = '0064923'; // VCC AGENCIA

				
		$codigo_presupuesto_prueba = '0000037781';
		$codigo_origen_sin_comisionista = '2';
		$codigo_origen_con_comisionista = '186';
		$codigo_afiliado_con_padre = '0064907';
		$codigo_afiliado_sin_padre = '0064906';
		
		$potencial_sin_comercial = new Potencial($codigo_potencial_sin_comercial);
		$potencial_sin_autocompra_con_comisionista_sin_rapel = new Potencial($codigo_potencial_sin_autocompra_con_comisionista_sin_rapel);
		$potencial_sin_autocompra_con_comisionista_con_rapel = new Potencial($codigo_potencial_sin_autocompra_con_comisionista_con_rapel);
		$potencial_con_autocompra_con_comisionista_sin_rapel = new Potencial($codigo_potencial_con_autocompra_con_comisionista_sin_rapel);
		$potencial_con_autocompra_con_comisionista_con_rapel = new Potencial($codigo_potencial_con_autocompra_con_comisionista_con_rapel);
				 
		$presupuesto = new Presupuesto($codigo_presupuesto_prueba);
		
		$origen_sin_comisionista = new Origen($codigo_origen_sin_comisionista);
		$origen_con_comisionista = new Origen($codigo_origen_con_comisionista);
		$comisionista_origen = $origen_con_comisionista->getCodigoComisionista();
		$potencial_afiliado_sin_padre = new Potencial($codigo_afiliado_sin_padre);
		$potencial_afiliado_con_padre = new Potencial($codigo_afiliado_con_padre);
		$comisionista_afiliado_con_padre = $potencial_afiliado_con_padre->getCodigoComisionista();
		$comisionista_afiliado_sin_padre = $potencial_afiliado_sin_padre->getCodigoComisionista();
		
		echo 'COMISIONISTAS DE PRESUPUESTO<br>';
		
		$presupuesto->setCodigoPotencial($codigo_potencial_sin_comercial);
		
		$presupuesto->asignarComisionistas($codigo_origen_sin_comisionista, '');
		if ( ($presupuesto->getComercial() == '') && ($presupuesto->getComisionista1() == '') && ($presupuesto->getComisionista2() == ''))
		echo 'OK'; else echo '<span style="background-color:#F00">---- KO</span>';
		echo ' ### Origen sin comisionista - No afiliado - No autocontratar - Potencial sin comercial:<br> 
				comercial = vacio, comisionista1 = vacio, comisionista2 = vacio<br>';

		$presupuesto->asignarComisionistas($codigo_origen_sin_comisionista, $codigo_afiliado_sin_padre);			
		if( ($presupuesto->getComercial() == $comisionista_afiliado_sin_padre) && 
			($presupuesto->getComisionista1() == $comisionista_afiliado_sin_padre) && 
			($presupuesto->getComisionista2() == '') )
		echo 'OK'; else echo '<span style="background-color:#F00">---- KO</span>';
		echo ' ### Origen sin comisionista - Afiliado 1 comisionista - Potencial sin comercial: 
				comercial = afiliado , comisionista1 = afiliado , comisinista2 = vacio';
		echo '<br>';
		
		$presupuesto->asignarComisionistas($codigo_origen_sin_comisionista, $codigo_afiliado_con_padre);
		if ( ($presupuesto->getComercial() == $comisionista_afiliado_con_padre) && 
			($presupuesto->getComisionista1() == $comisionista_afiliado_sin_padre) && 
			($presupuesto->getComisionista2() == $comisionista_afiliado_con_padre ))
		echo 'OK'; else echo '<span style="background-color:#F00">---- KO</span>';
		echo ' ### Origen sin comisionista - Afiliado Comisionista Con Padre - Potencial sin comisionista: 
				comercial=afiliado con padre, comisionista1 = afiliado sin padre, comisionista2=afiliado con padre';
		echo '<br>';
		
		// Origen con comisionista
		$presupuesto->asignarComisionistas($codigo_origen_con_comisionista, '');
		if ( ($presupuesto->getComercial() == $origen_con_comisionista->getCodigoComisionista()) && 
			 ($presupuesto->getComisionista1() == $origen_con_comisionista->getCodigoComisionista()) &&
			 ($presupuesto->getComisionista2() == '' ) 
			)
		echo 'OK'; else echo '<span style="background-color:#F00">---- KO</span>';
		echo ' ### Origen con comisionista - No afiliado - Potencial sin comisionista:<br> 
				comercial=comisionsita origen, comisionista1=comisionista origen, comisionista2 = vacio';
		echo '<br>';
		
		$presupuesto->asignarComisionistas($codigo_origen_con_comisionista, $codigo_afiliado_sin_padre);
		if ( ($presupuesto->getComercial() == $comisionista_afiliado_sin_padre) && 
				($presupuesto->getComisionista1()== $comisionista_origen) &&
				($presupuesto->getComisionista2() == $comisionista_afiliado_sin_padre)  
			)
		echo 'OK'; else echo '<span style="background-color:#F00">---- KO</span>';
		echo ' ### Origen con comisionista - Afiliado 1 Comisionista - Potencial sin comisionista: 
				comercial=comisionista afiliado, comisionista1=comision origen, comisionista2 = comisionista afiliado';
		echo '<br>';
		
		$presupuesto->asignarComisionistas($codigo_origen_con_comisionista, $codigo_afiliado_con_padre);
		if ( ($presupuesto->getComercial() == $comisionista_afiliado_con_padre) && 
				($presupuesto->getComisionista1()== $comisionista_origen) &&
				($presupuesto->getComisionista2() == $comisionista_afiliado_con_padre)  
			)
		echo 'OK'; else echo '<span style="background-color:#F00">---- KO</span>';
		echo ' ### Origen con comisionista - Afiliado Comisionista con padre - Potencial sin comisionista:  
				comercial=comisionista afiliado, comisionista1=comision origen, comisionista2 = comisionista afiliado';
		echo '<br>';
		
		// ORIGEN SIN COMISIONISTA
		$presupuesto->setCodigoPotencial($codigo_potencial_sin_autocompra_con_comisionista_sin_rapel);

		$presupuesto->asignarComisionistas($codigo_origen_sin_comisionista, '');
		if (($presupuesto->getComercial() == $potencial_sin_autocompra_con_comisionista_sin_rapel->getComercial()) && 
			($presupuesto->getComisionista1() == $potencial_sin_autocompra_con_comisionista_sin_rapel->getComercial()) &&
			($presupuesto->getComisionista2() == '')  
			) echo 'OK'; else echo '<span style="background-color:#F00">---- KO</span>';
		echo ' ### Origen sin comisionista - No afiliado - NO Autocompra - Potencial con un comisionista: <br>
				comercial = comercial del potencial, comisionista = comercial del potencial, comisionista2 = vacio';
		echo '<br>';
		
		$presupuesto->setCodigoPotencial($codigo_potencial_sin_autocompra_con_comisionista_con_rapel);
		$presupuesto->asignarComisionistas($codigo_origen_sin_comisionista, '');
		if (($presupuesto->getComercial() == $potencial_sin_autocompra_con_comisionista_con_rapel->getComercial()) &&
				($presupuesto->getComisionista1() == $potencial_sin_autocompra_con_comisionista_con_rapel->getComercialPadre()) &&
				($presupuesto->getComisionista2() == $potencial_sin_autocompra_con_comisionista_con_rapel->getComercial())
		) echo 'OK'; else echo '<span style="background-color:#F00">---- KO</span>';
		echo ' ### Origen sin comisionista - No afiliado - NO Autocompra - Potencial con dos comisionistas:<br>
				comercial = comisionista potencial, comisionista = comisionista padre del potencial, comisionista2 = comisionista potencial';
		echo '<br>';
		
		$presupuesto->setCodigoPotencial($codigo_potencial_sin_autocompra_con_comisionista_sin_rapel);
		$presupuesto->asignarComisionistas($codigo_origen_sin_comisionista, $codigo_afiliado_sin_padre);
		if (($presupuesto->getComercial() == $comisionista_afiliado_sin_padre) &&
			($presupuesto->getComisionista1() == $comisionista_afiliado_sin_padre) &&
			($presupuesto->getComisionista2() == '')
		) echo 'OK'; else echo '<span style="background-color:#F00">---- KO</span>';
		echo ' ### Origen sin comisionista - Afiliado 1 Comisionista - NO Autocompra - Potencial 1 comisionista: <br>
				comercial = comisionista afiliado, comisionista = comisionista afiliado, comisionista2 = vacio';
		echo '<br>';

		$presupuesto->setCodigoPotencial($codigo_potencial_sin_autocompra_con_comisionista_con_rapel);
		$presupuesto->asignarComisionistas($codigo_origen_sin_comisionista, $codigo_afiliado_sin_padre);
		if (($presupuesto->getComercial() == $comisionista_afiliado_sin_padre) &&
				($presupuesto->getComisionista1() == $comisionista_afiliado_sin_padre) &&
				($presupuesto->getComisionista2() == '')
		) echo 'OK'; else echo '<span style="background-color:#F00">---- KO</span>';
		echo ' ### Origen sin comisionista - Afiliado 1 Comisionista - NO Autocompra - Potencial 2 comisionista: <br>
				comercial = comisionista afiliado, comisionista = comisionista afiliado, comisionista2 = vacio';
		echo '<br>';

		$presupuesto->setCodigoPotencial($codigo_potencial_sin_autocompra_con_comisionista_sin_rapel);
		$presupuesto->asignarComisionistas($codigo_origen_sin_comisionista, $codigo_afiliado_con_padre);
		if (($presupuesto->getComercial() == $comisionista_afiliado_con_padre) &&
				($presupuesto->getComisionista1() == $comisionista_afiliado_sin_padre) &&
				($presupuesto->getComisionista2() == $comisionista_afiliado_con_padre)
		) echo 'OK'; else echo '<span style="background-color:#F00">---- KO</span>';
		echo ' ### Origen sin comisionista - Afiliado 2 Comisionistas - NO Autocompra - Potencial 1 comisionista: <br>
				comercial = comisionista afiliado, comisionista = comisionista afiliado padre, comisionista2 = comisionista afiliado';
		echo '<br>';
		
		$presupuesto->setCodigoPotencial($codigo_potencial_sin_autocompra_con_comisionista_con_rapel);
		$presupuesto->asignarComisionistas($codigo_origen_sin_comisionista, $codigo_afiliado_con_padre);
		if (($presupuesto->getComercial() == $comisionista_afiliado_con_padre) &&
				($presupuesto->getComisionista1() == $comisionista_afiliado_sin_padre) &&
				($presupuesto->getComisionista2() == $comisionista_afiliado_con_padre)
		) echo 'OK'; else echo '<span style="background-color:#F00">---- KO</span>';
		echo ' ### Origen sin comisionista - Afiliado 2 Comisionistas - NO Autocompra - Potencial 2 comisionista: <br>
				comercial = comisionista afiliado, comisionista = comisionista afiliado padre, comisionista2 = comisionista afiliado';
		echo '<br>';
		
		$presupuesto->setCodigoPotencial($codigo_potencial_sin_autocompra_con_comisionista_sin_rapel);
		$presupuesto->asignarComisionistas($codigo_origen_con_comisionista, '');
		if (($presupuesto->getComercial() == $comisionista_origen) &&
			($presupuesto->getComisionista1() == $comisionista_origen) &&
			($presupuesto->getComisionista2() == '')
		) echo 'OK'; else echo '<span style="background-color:#F00">---- KO</span>';
		echo ' ### Origen con comisionista - No afiliado - No autocompra - Potencial 1 comisionista<br>
				comercial = origen, comisionista= origen, comisionista2 = vacio';
		echo '<br/>';

		$presupuesto->setCodigoPotencial($codigo_potencial_sin_autocompra_con_comisionista_con_rapel);
		$presupuesto->asignarComisionistas($codigo_origen_con_comisionista, '');
		if (($presupuesto->getComercial() == $comisionista_origen) &&
			($presupuesto->getComisionista1() == $comisionista_origen) &&
			($presupuesto->getComisionista2() == '')
		) echo 'OK'; else echo '<span style="background-color:#F00">---- KO</span>';
		echo ' ### Origen con comisionista - No afiliado - No autocompra - Potencial 2 comisionista<br>
				comercial = origen, comisionista= origen, comisionista2 = vacio';
		echo '<br/>';

		$presupuesto->setCodigoPotencial($codigo_potencial_sin_autocompra_con_comisionista_sin_rapel);
		$presupuesto->asignarComisionistas($codigo_origen_con_comisionista, $codigo_afiliado_sin_padre);
		if (($presupuesto->getComercial() == $comisionista_afiliado_sin_padre) &&
			($presupuesto->getComisionista1() == $comisionista_origen) &&
			($presupuesto->getComisionista2() == $comisionista_afiliado_sin_padre)
		) echo 'OK'; else echo '<span style="background-color:#F00">---- KO</span>';
		echo ' ### Origen con comisionista - Afiliado 1 comisionista - No autocompra - Potencial 1 comisionista<br>
				comercial = afiliado, comisionista= origen, comisionista2 = afiliado';
		echo '<br/>';
		
		$presupuesto->setCodigoPotencial($codigo_potencial_sin_autocompra_con_comisionista_con_rapel);
		$presupuesto->asignarComisionistas($codigo_origen_con_comisionista, $codigo_afiliado_sin_padre);
		if (($presupuesto->getComercial() == $comisionista_afiliado_sin_padre) &&
			($presupuesto->getComisionista1() == $comisionista_origen) &&
			($presupuesto->getComisionista2() == $comisionista_afiliado_sin_padre)
		) echo 'OK'; else echo '<span style="background-color:#F00">---- KO</span>';
		echo ' ### Origen con comisionista - Afiliado 1 comisionista - No autocompra - Potencial 2 comisionista<br>
				comercial = afiliado, comisionista= origen, comisionista2 = afiliado';
		echo '<br/>';
		
		$presupuesto->setCodigoPotencial($codigo_potencial_con_autocompra_con_comisionista_sin_rapel);
		$presupuesto->asignarComisionistas($codigo_origen_sin_comisionista, '');
		if (($presupuesto->getComercial() == $potencial_con_autocompra_con_comisionista_sin_rapel->getComercial()) &&
			($presupuesto->getComisionista1() == $potencial_con_autocompra_con_comisionista_sin_rapel->getComercial()) &&
			($presupuesto->getComisionista2() == '')
		) echo 'OK'; else echo '<span style="background-color:#F00">---- KO</span>';		
		echo ' ### Origen sin comisionista - No Afiliado - Autocompra - Potencial 1 comisionista:<br>
				comercial= comercial potencial, comisionista1=comercial potencial , comisionista2=vacio ';
		echo '<br>';
		
		$presupuesto->setCodigoPotencial($codigo_potencial_con_autocompra_con_comisionista_con_rapel);
		$presupuesto->asignarComisionistas($codigo_origen_sin_comisionista, '');
		if (($presupuesto->getComercial() == $potencial_con_autocompra_con_comisionista_con_rapel->getComercial()) &&
			($presupuesto->getComisionista1() == $potencial_con_autocompra_con_comisionista_con_rapel->getComercialPadre()) &&
			($presupuesto->getComisionista2() == $potencial_con_autocompra_con_comisionista_con_rapel->getComercial())
		) echo 'OK'; else echo '<span style="background-color:#F00">---- KO</span>';
		echo ' ### Origen sin comisionista - No Afiliado - Autocompra - Potencial 2 comisionista:<br>
				comercial= comercial potencial, comisionista1=comercial padre potencial , comisionista2= comercial potencial ';
		echo '<br>';
		
		$presupuesto->setCodigoPotencial($codigo_potencial_con_autocompra_con_comisionista_sin_rapel);
		$presupuesto->asignarComisionistas($codigo_origen_sin_comisionista, $codigo_afiliado_sin_padre);
		if (($presupuesto->getComercial() == $potencial_con_autocompra_con_comisionista_sin_rapel->getComercial()) &&
				($presupuesto->getComisionista1() == $potencial_con_autocompra_con_comisionista_sin_rapel->getComercial()) &&
				($presupuesto->getComisionista2() == '')
		) echo 'OK'; else echo '<span style="background-color:#F00">---- KO</span>';
		echo ' ### Origen sin comisionista - Afiliado 1 comisionista - Autocompra - Potencial 1 comisionista:<br>
				comercial = comercial potencial, comisionista1= comisionista potencial , comisionista2= vacio';
		echo '<br>';
		
		$presupuesto->setCodigoPotencial($codigo_potencial_con_autocompra_con_comisionista_con_rapel);
		$presupuesto->asignarComisionistas($codigo_origen_sin_comisionista, $codigo_afiliado_sin_padre);
		if (($presupuesto->getComercial() == $potencial_con_autocompra_con_comisionista_con_rapel->getComercial()) &&
			($presupuesto->getComisionista1() == $potencial_con_autocompra_con_comisionista_con_rapel->getComercialPadre()) &&
			($presupuesto->getComisionista2() == $potencial_con_autocompra_con_comisionista_con_rapel->getComercial())
		) echo 'OK'; else echo '<span style="background-color:#F00">---- KO</span>';
		echo ' ### Origen sin comisionista - Afiliado 1 comisionista - Autocompra - Potencial 2 comisionista:<br>
				comercial = comercial potencial, comisionista1= comisionista potencial padre, comisionista2= comercial potencial';
		echo '<br>';

		$presupuesto->setCodigoPotencial($codigo_potencial_con_autocompra_con_comisionista_sin_rapel);
		$presupuesto->asignarComisionistas($codigo_origen_sin_comisionista, $codigo_afiliado_con_padre);
		if (($presupuesto->getComercial() == $potencial_con_autocompra_con_comisionista_sin_rapel->getComercial()) &&
				($presupuesto->getComisionista1() == $potencial_con_autocompra_con_comisionista_sin_rapel->getComercial()) &&
				($presupuesto->getComisionista2() == '')
		) echo 'OK'; else echo '<span style="background-color:#F00">---- KO</span>';
		echo ' ### Origen sin comisionista - Afiliado 2 comisionista - Autocompra - Potencial 1 comisionista:<br>
				comercial = comercial potencial, comisionista1= comisionista potencial , comisionista2= vacio';
		echo '<br>';
		
		$presupuesto->setCodigoPotencial($codigo_potencial_con_autocompra_con_comisionista_con_rapel);
		$presupuesto->asignarComisionistas($codigo_origen_sin_comisionista, $codigo_afiliado_con_padre);
		if (($presupuesto->getComercial() == $potencial_con_autocompra_con_comisionista_con_rapel->getComercial()) &&
				($presupuesto->getComisionista1() == $potencial_con_autocompra_con_comisionista_con_rapel->getComercialPadre()) &&
				($presupuesto->getComisionista2() == $potencial_con_autocompra_con_comisionista_con_rapel->getComercial())
		) echo 'OK'; else echo '<span style="background-color:#F00">---- KO</span>';
		echo ' ### Origen sin comisionista - Afiliado 2 comisionista - Autocompra - Potencial 2 comisionista:<br>
				comercial = comercial potencial, comisionista1= comisionista potencial padre, comisionista2= comercial potencial';
		echo '<br>';
		
	//------------------------------------------------------

		$presupuesto->setCodigoPotencial($codigo_potencial_con_autocompra_con_comisionista_sin_rapel);
		$presupuesto->asignarComisionistas($codigo_origen_con_comisionista, '');
		if (($presupuesto->getComercial() == $potencial_con_autocompra_con_comisionista_sin_rapel->getComercial()) &&
				($presupuesto->getComisionista1() == $potencial_con_autocompra_con_comisionista_sin_rapel->getComercial()) &&
				($presupuesto->getComisionista2() == '')
		) echo 'OK'; else echo '<span style="background-color:#F00">---- KO</span>';
		echo ' ### Origen con comisionista - No Afiliado - Autocompra - Potencial 1 comisionista:<br>
				comercial= comercial potencial, comisionista1=comercial potencial , comisionista2=vacio ';
		echo '<br>';
		
		$presupuesto->setCodigoPotencial($codigo_potencial_con_autocompra_con_comisionista_con_rapel);
		$presupuesto->asignarComisionistas($codigo_origen_con_comisionista, '');
		if (($presupuesto->getComercial() == $potencial_con_autocompra_con_comisionista_con_rapel->getComercial()) &&
			($presupuesto->getComisionista1() == $potencial_con_autocompra_con_comisionista_con_rapel->getComercialPadre()) &&
			($presupuesto->getComisionista2() == $potencial_con_autocompra_con_comisionista_con_rapel->getComercial())
		) echo 'OK'; else echo '<span style="background-color:#F00">---- KO</span>';
		echo ' ### Origen con comisionista - No Afiliado - Autocompra - Potencial 2 comisionista:<br>
				comercial= comercial potencial, comisionista1=comercial padre potencial , comisionista2= comercial potencial ';
		echo '<br>';
		
		
		$presupuesto->setCodigoPotencial($codigo_potencial_con_autocompra_con_comisionista_sin_rapel);
		$presupuesto->asignarComisionistas($codigo_origen_con_comisionista, $codigo_afiliado_sin_padre);
		if (($presupuesto->getComercial() == $potencial_con_autocompra_con_comisionista_sin_rapel->getComercial()) &&
			($presupuesto->getComisionista1() == $potencial_con_autocompra_con_comisionista_sin_rapel->getComercial()) &&
			($presupuesto->getComisionista2() == '')
		) echo 'OK'; else echo '<span style="background-color:#F00">---- KO</span>';
		echo ' ### Origen con comisionista - Afiliado 1 comisionista - Autocompra - Potencial 1 comisionista:<br>
				comercial = comercial potencial, comisionista1= comisionista potencial , comisionista2= vacio';
		echo '<br>';
		
		$presupuesto->setCodigoPotencial($codigo_potencial_con_autocompra_con_comisionista_con_rapel);
		$presupuesto->asignarComisionistas($codigo_origen_con_comisionista, $codigo_afiliado_sin_padre);
		if (($presupuesto->getComercial() == $potencial_con_autocompra_con_comisionista_con_rapel->getComercial()) &&
				($presupuesto->getComisionista1() == $potencial_con_autocompra_con_comisionista_con_rapel->getComercialPadre()) &&
				($presupuesto->getComisionista2() == $potencial_con_autocompra_con_comisionista_con_rapel->getComercial())
		) echo 'OK'; else echo '<span style="background-color:#F00">---- KO</span>';
		echo ' ### Origen con comisionista - Afiliado 1 comisionista - Autocompra - Potencial 2 comisionista:<br>
				comercial = comercial potencial, comisionista1= comisionista potencial padre, comisionista2= comercial potencial';
		echo '<br>';
		
		$presupuesto->setCodigoPotencial($codigo_potencial_con_autocompra_con_comisionista_sin_rapel);
		$presupuesto->asignarComisionistas($codigo_origen_con_comisionista, $codigo_afiliado_con_padre);
		if (($presupuesto->getComercial() == $potencial_con_autocompra_con_comisionista_sin_rapel->getComercial()) &&
				($presupuesto->getComisionista1() == $potencial_con_autocompra_con_comisionista_sin_rapel->getComercial()) &&
				($presupuesto->getComisionista2() == '')
		) echo 'OK'; else echo '<span style="background-color:#F00">---- KO</span>';
		echo ' ### Origen con comisionista - Afiliado 2 comisionista - Autocompra - Potencial 1 comisionista:<br>
				comercial = comercial potencial, comisionista1= comisionista potencial , comisionista2= vacio';
		echo '<br>';
		
		$presupuesto->setCodigoPotencial($codigo_potencial_con_autocompra_con_comisionista_con_rapel);
		$presupuesto->asignarComisionistas($codigo_origen_con_comisionista, $codigo_afiliado_con_padre);
		if (($presupuesto->getComercial() == $potencial_con_autocompra_con_comisionista_con_rapel->getComercial()) &&
				($presupuesto->getComisionista1() == $potencial_con_autocompra_con_comisionista_con_rapel->getComercialPadre()) &&
				($presupuesto->getComisionista2() == $potencial_con_autocompra_con_comisionista_con_rapel->getComercial())
		) echo 'OK'; else echo '<span style="background-color:#F00">---- KO</span>';
		echo ' ### Origen con comisionista - Afiliado 2 comisionista - Autocompra - Potencial 2 comisionista:<br>
				comercial = comercial potencial, comisionista1= comisionista potencial padre, comisionista2= comercial potencial';
		echo '<br>';
		
		
		/*
		$presupuesto->asignarComisionistas($origen, $afiliadoComisionista);
		echo ' ### Origen sin comisionista - El potencial existe y su comercial SI es él mismo';
		
		$presupuesto->asignarComisionistas($origen, $afiliadoComisionista);
		echo ' ????? ### Origen sin comisionista Pasándole un comisionista ????'; 
		
		$presupuesto->asignarComisionistas($origen, $afiliadoComisionista);
		echo ' ### Origen con comisionista - El potencial es nuevo en el sistema';
		
		$presupuesto->asignarComisionistas($origen, $afiliadoComisionista);
		echo ' ### Origen con comisionista - El potencial existe y su comercial NO es él mismo';
		
		$presupuesto->asignarComisionistas($origen, $afiliadoComisionista);
		echo ' ### Origen con comisionista - El potencial existe y su comercial SI es él mismo';
		*/
		
		die();
		
	}
	
	public function contratarporwebAction(){
		
		$email_de_potencial = 'vcc.cliente.comisionista.padre@gmail.com';
		$codigo_de_potencial = '0064286';
		$pot = Potencial::getByEmail($email_de_potencial);
		if ($pot->getCodigo()== $codigo_de_potencial) echo 'OK'; else echo 'KO';
		echo ' ### El potencial para '.$email_de_potencial.' es '.$codigo_de_potencial;
		echo '<br/>';
		
		$email_de_potencial_no_registrado = 'noregistrado@aaa.com';
		$codigo_de_potencial = '';
		$pot = Potencial::getByEmail($email_de_potencial_no_registrado);
		if ($pot instanceof Potencial) echo 'OK'; else echo 'KO';
		echo ' ### El potencial es objeto POTENCIAL.';
		echo '<br/>';
		
		if ($pot->getCodigo()== $codigo_de_potencial) echo 'OK'; else echo 'KO';
		echo ' ### El potencial con el email '.$email_de_potencial_no_registrado.' no está registrado '.$email_de_potencial_no_registrado;
		echo '<br/>';
		
		$numero_email_repetidos = count(Potencial::getEmailRepetidos());
		if ($numero_email_repetidos==0) echo 'OK'; else echo 'KO';
		echo ' ### No hay contactos con email repetidos. Repeticiones:'.$numero_email_repetidos;
		echo '<br/>';

		die();
	}
	
	public function asignarpotencialAction(){
		
		$lang = 'ES-ES';
		$codigoOrigen = 2;
		$origen = new Origen($codigoOrigen);
		$idioma = Idioma::langToIdioma($lang);
		// inicializar variables
		$_em_codigoTexto = '';
		$_em_vista = 'notificacion_cliente';
		$_em_codigoPresupuesto = '';
		$_em_codigoPotencial = '';
		$_em_boton = '';
		$_em_lang = $lang;
		$_em_url = '';
		
		
		$codigoPresupuesto = '0000037781';
		$email_de_potencial = 'vcc.cliente.comisionista.hijo@gmail.com';
		$potencial = Potencial::getByEmail($email_de_potencial);
		$presupuesto = new Presupuesto($codigoPresupuesto);
				
		if ($potencial->getEstaEmailValidado()){
			// datos para el email
			$_em_codigoTexto = Texto::TEXTO_PETICION_PRESUPUESTO_RECIBIDA;		
		} else {
			// datos para el email
			$urlOrigen = $origen->getUrl();	
			$_em_codigoTexto = Texto::TEXTO_VALIDAR_EMAIL;
			$_em_codigoPresupuesto = $presupuesto->getCodigoPresupuesto();
			$_em_codigoPotencial = $potencial->getCodigo();
			$_em_url = "http://" . $urlOrigen;
		}
		
		// Mandamos email para confirmar que existe
		
		$texto = new Texto($_em_codigoTexto, $idioma);
		
		$email = new Email();
		$email->addDestinatario($potencial->getNombre(), $potencial->getEmail());
		$email->setAsunto($texto->getTitulo());
		$email->setVista($_em_vista);
		$email->url = $_em_url;
		$email->codigoPresupuesto = $_em_codigoPresupuesto;
		$email->codigoPotencial = $_em_codigoPotencial;
		$email->titulo = $texto->getTitulo();
		$email->boton = $texto->getLabelAsunto();
		$email->mensaje = $texto->getTexto();
		$email->lang = $_em_lang;;
		
		echo $email->renderVista();
		//$email->enviar();
		die();
		
	}
	
	public function emailAction(){
		/*
		// validar email
		$_em_codigoTexto = Texto::TEXTO_VALIDAR_EMAIL;
		$_em_asunto = 'Confirmación del email';
		$_em_vista = 'validaremail';
		$_em_action = 'validaremail';
		$_em_origen = 2; //LCC
		$_em_email_potencial = 'vcc.cliente.comisionista.padre@gmail.com';		
		$idioma = Idioma::IDIOMA_ESPAÑOL;
		$token = 'token';
		$numeroPresupuesto = '0000037836';
		$lang = Idioma::IDIOMA_ESPAÑOL;
		$presupuesto = new Presupuesto($numeroPresupuesto);
	
		$origen = new Origen($_em_origen);
		$potencial = Potencial::getByEmail($_em_email_potencial);
		$texto = new Texto($_em_codigoTexto, $idioma);
		$urlOrigen = $origen->getUrl();
		$email = new Email();
		$url = "http://" . $urlOrigen;
		$email->url = $url;
		$email->addDestinatario($potencial->getNombre(), $potencial->getEmail());
		$email->setAsunto($_em_asunto);
		$email->setVista($_em_vista);
		$email->origen = $origen;
		$email->token = $token;
		$email->codigoPresupuesto = $presupuesto->getCodigoPresupuesto();
		$email->codigoPotencial = $potencial->getCodigo();
		$email->action = $_em_action;
		$email->titulo = $texto->getTitulo();
		$email->boton = $texto->getLabelAsunto();
		$email->mensaje = $texto->getTexto();
		$email->lang = $lang;
		echo $email->renderVista();
		//echo $potencial->getEmail();
		*/
		
		// peticion recibida
		$_em_codigoTexto = Texto::TEXTO_PETICION_PRESUPUESTO_RECIBIDA;
		$_em_vista = 'validaremail';
		$_em_origen = 2; //LCC
		$_em_email_potencial = 'vcc.cliente.comisionista.padre@gmail.com';
		$idioma = Idioma::IDIOMA_ESPAÑOL;
		$numeroPresupuesto = '0000037836';
		$presupuesto = new Presupuesto($numeroPresupuesto);
		
		$origen = new Origen($_em_origen);
		$potencial = Potencial::getByEmail($_em_email_potencial);
		$texto = new Texto($_em_codigoTexto, $idioma);
		$urlOrigen = $origen->getUrl();
		$email = new Email();
		$email->addDestinatario($potencial->getNombre(), $potencial->getEmail());
		$email->setAsunto($texto->getTitulo());
		$email->setVista($_em_vista);
		$email->titulo = $texto->getTitulo();
		$email->mensaje = $texto->getTexto();
		echo $email->renderVista();
		
		die();
	}
	
	public function sesionAction(){
		
		/* Administrador */
		$usuarioProbado = 'lcc';
		$numeroPotencialUsuarioLogueado = '0001136';
		$perfilesDelUsuario = array(
				Potencial::PERFIL_CHOFER => true,
				Potencial::PERFIL_COMERCIAL =>true,
				Potencial::PERFIL_PROVEEDOR => true
		);
							
		// Fin de validación
		
		echo '<h4>OJO: Esto se valida cuando recién validado de login. Luego se borrar las session. </br>
				Las pruebas se valida con el usuario "'.$usuarioProbado.'".</h4>';
		echo '<br>';
		$ses = Sesion::set('TEST', 5);
		if (Sesion::get('TEST')==5) echo 'OK'; else echo '-----KO';
		echo ' ### La sesión TEST es igual a 5. ';
		echo '<br>';
		$numeroPotencialUsuarioLogueado= Sesion::get(Sesion::POTENCIAL_NUMERO);
		if (Sesion::get(Sesion::POTENCIAL_NUMERO)==$numeroPotencialUsuarioLogueado) echo 'OK'; else echo '-----KO';
		echo ' ### El número de potencial validado es '.$numeroPotencialUsuarioLogueado.':';
		echo '<br>';
		$usuario = Sesion::get(Sesion::POTENCIAL_OBJETO);
		if ($usuario instanceof Potencial) echo 'OK'; else echo '-----KO';
		echo ' ### El usuario validado de la sesion es potencial:';
		echo '<br>';
		$potencial = Usuario::getPotencialLogueado();
		if ($potencial instanceof Potencial) echo 'OK'; else echo '-----KO';
		echo ' ### El usuario recuperado de getLogueado es potencial:';
		if ($potencial instanceof Potencial){
			foreach ($perfilesDelUsuario as $perfil => $valor) {
				echo '<br/>';
				if ($potencial->tienePerfil($perfil) === $valor) echo 'OK'; else echo '-----KO';
				echo " ### El usuario ".(($valor)?'SI':'NO')." tiene perfil $perfil.";			
			}
		}
		Sesion::borrar();
		echo '<br>';
		if (is_null(Sesion::get(Sesion::POTENCIAL_NUMERO))) echo 'OK'; else echo '-----KO';
		echo ' ### Se ha borrado la sesión.';
		
		// Pruebas para VCC PADRE
		
		$usuarioAProbar = 'VCCPADRE';
		$passwordAProbar = 'VCCPADRE';
		$numeroPotencialAProbar = '0064248';
		$numeroComisionistaAProbar = '0588000';
		$numeroPresupuestosActivos = 0;
		$perfilDefectoAProbar = Potencial::PERFIL_COMERCIAL;
		$perfilesDelUsuario = array(
				Potencial::PERFIL_CHOFER => false,
				Potencial::PERFIL_COMERCIAL =>true,
				Potencial::PERFIL_PROVEEDOR => false
		);
		
		self::testLogin($usuarioAProbar, $passwordAProbar, $numeroPotencialAProbar, $perfilesDelUsuario, $perfilDefectoAProbar, $numeroComisionistaAProbar, $numeroPresupuestosActivos);
		
		// Pruebas para VCC HIJO
		
		$usuarioAProbar = 'VCCHIJO';
		$passwordAProbar = 'VCCHIJO';
		$numeroPotencialAProbar = '0064249';
		$numeroComisionistaAProbar = '0588001';
		$numeroPresupuestosActivos = 2;
		$perfilDefectoAProbar = Potencial::PERFIL_COMERCIAL;		
		$perfilesDelUsuario = array(
				Potencial::PERFIL_CHOFER => false,
				Potencial::PERFIL_COMERCIAL =>true,
				Potencial::PERFIL_PROVEEDOR => false
		);
		
		self::testLogin($usuarioAProbar, $passwordAProbar, $numeroPotencialAProbar, $perfilesDelUsuario, $perfilDefectoAProbar, $numeroComisionistaAProbar, $numeroPresupuestosActivos);
		
		// Pruebas para VCC CLIENTE
		
		$usuarioAProbar = 'VCCCLIENTE';
		$passwordAProbar = 'VCCCLIENTE';
		$numeroPotencialAProbar = '0060874';
		$numeroComisionistaAProbar = '';
		$numeroPresupuestosActivos = 0;
		$perfilDefectoAProbar = null;
		$perfilesDelUsuario = array(
				Potencial::PERFIL_CHOFER => false,
				Potencial::PERFIL_COMERCIAL =>false,
				Potencial::PERFIL_PROVEEDOR => false
		);
		
		self::testLogin($usuarioAProbar, $passwordAProbar, $numeroPotencialAProbar, $perfilesDelUsuario, $perfilDefectoAProbar, $numeroComisionistaAProbar, $numeroPresupuestosActivos);
		
		// Pruebas para VCC PROVEEDOR
		
		$usuarioAProbar = 'VCCPROVEEDOR';
		$passwordAProbar = 'VCCPROVEEDOR';
		$numeroPotencialAProbar = '0064254';
		$numeroComisionistaAProbar = '';
		$perfilDefectoAProbar = Potencial::PERFIL_PROVEEDOR;
		$numeroPresupuestosActivos = 0;
		$perfilesDelUsuario = array(
				Potencial::PERFIL_CHOFER => false,
				Potencial::PERFIL_COMERCIAL =>false,
				Potencial::PERFIL_PROVEEDOR => true
		);
		
		self::testLogin($usuarioAProbar, $passwordAProbar, $numeroPotencialAProbar, $perfilesDelUsuario, $perfilDefectoAProbar, $numeroComisionistaAProbar, $numeroPresupuestosActivos);
		
		die();
	}
	
	private static function testLogin($usuarioAProbar, $passwordAProbar,
							$numeroPotencialAProbar, $perfilesDelUsuario, 
							$perfilPorDefecto, $numeroComisionistaAProbar, 
							$numeroPresupuestosActivos){
		echo '<h4>Usuario: '.$usuarioAProbar.'</h4>';
		$usuarioParaValidar = new Usuario();
		try {
			$usuarioParaValidar->login($usuarioAProbar, $passwordAProbar);
		} catch(Exception $e){
			echo $e->getMessage();
			die('EXCEPTION');
		}
		
		if (Sesion::get(Sesion::POTENCIAL_NUMERO)==$numeroPotencialAProbar) echo 'OK'; else echo '-----KO';
		echo ' ### El número de potencial validado es '.$numeroPotencialAProbar.'.';
		$numeroPotencialAProbar= Sesion::get(Sesion::POTENCIAL_NUMERO);
		
		echo '<br>';
		$potencial = Usuario::getPotencialLogueado();
		if ($potencial instanceof Potencial) echo 'OK'; else echo '-----KO';
		echo ' ### El usuario recuperado de getLogueado es potencial.';
		
		if ($potencial instanceof Potencial){
			foreach ($perfilesDelUsuario as $perfil => $valor) {
				echo '<br/>';
				if ($potencial->tienePerfil($perfil) === $valor) echo 'OK'; else echo '-----KO';
				echo " ### El usuario ".(($valor)?'SI':'NO')." tiene perfil $perfil.";
			}
		}
		echo '<br>';
		$perfilesParaComparar = array();
		foreach ($perfilesDelUsuario as $perfil => $valor) {
			if ($valor) $perfilesParaComparar[]=$perfil;
		}
		$diff = array_diff($perfilesParaComparar,$potencial->getPerfilesDisponibles());
		if (empty($diff)) echo 'OK'; else echo '-----KO';
		echo ' ### Los perfiles se han cargado correctamente';
		
		echo '<br>';
		$perfilPorDefectoCalculado = $potencial->getPerfilActivo();
		if ($perfilPorDefecto == $perfilPorDefectoCalculado) echo 'OK'; else echo '-----KO';
		echo ' ### El perfil por defecto es correcto.';
		
		echo '<br>';
		$perfilACambiar = Potencial::PERFIL_COMERCIAL;
		$potencial->setPerfilActivo($perfilACambiar);
		if ($potencial->tienePerfil($perfilACambiar)) {
			if ($potencial->getPerfilActivo() == $perfilACambiar) echo 'OK'; else echo '-----KO';
			echo ' ### El perfil se ha cambiado correctamente.';
		} else {
			if ($potencial->getPerfilActivo() != $perfilACambiar) echo 'OK'; else echo '-----KO';
			echo ' ### El perfil no se ha cambiado porque no tiene ese perfil disponible.';
		}
		
		echo '<br>';
		$codigoComisionista = $potencial->getSuCodigoComisionista();
		if ($codigoComisionista == $numeroComisionistaAProbar) echo 'OK'; else echo '-----KO';
		echo ' ### El código de Comisionista es '.$numeroComisionistaAProbar.'.';
		
		$params = array();
		$res = Presupuesto::lst_activos($params);
		$numeroPresupuestosActivosEnBBDD = count($res->getDatos());
		echo '<br>';
		if ($numeroPresupuestosActivosEnBBDD == $numeroPresupuestosActivos) echo 'OK'; else echo '-----KO';
		echo ' ### Deben ser '.$numeroPresupuestosActivos.' presupuestos activos y son '.$numeroPresupuestosActivosEnBBDD.'.';
		
		echo '<br>';
		$url = $potencial->getUrlPorDefectoDependeDePerfil();
		echo $url;
			
	} 
			
	public function cobrosAction(){
		
		$numeroServicio = '0000006832';
		$cobros = Cobro::loadPorContrato($numeroServicio);
		print_r($cobros);
		die();
		
	}
	
	public function logueadorAction(){

		$numeroPresupuesto = $this->getParametro('np');
		
		/*$usuario = new Usuario();
		$usu = Usuario::loadPorToken('255127f3f5c2255d1ee771f656942226');
	*/
		$usuario = Usuario::UsuarioLoqueado();
		
		// Visual
		$ly = $this->getLayout();
		$cad_presupuesto = 'El número de presupuesto es: '.$numeroPresupuesto.'<br/>';
		$cad_usuario = 'El usuario es el número: '.$usuario->NUMERO.'<br/>';
		$cad_nombre = 'El usuario tienen el nombre: '.$usuario->NOMBRE.'<br/>';
		$ly->reg_contenido->addElement($cad_presupuesto);
		$ly->reg_contenido->addElement($cad_usuario);
		$ly->reg_contenido->addElement($cad_nombre);
		
	}
	
	public function vehiculoAction(){
		
		$vehi = new Vehiculo('0000232');
		$vehi->setOficinaActual('AR');
		$vehi->save();
		print_r($vehi);
		
		$vehi2 = new Vehiculo('0000232');
		print_r($vehi2);
		die();
		
	}
	
	public function oficinaAction(){
		$codigoPropietario = '0000033';
		$res = Oficina::loadComboPorPropietario($codigoPropietario);
		print_r($res);
		die();
		
	}
	
	public function ofertaAction(){
		
		$numeroPresupuesto = '0000000365';
		$numeroProveedor = '0000303';
		$oferta = new PresupuestoProveedor($numeroPresupuesto, $numeroProveedor);
		print_r($oferta);
		$oferta->setCoste(750);
		$oferta->save();
		
	}

	public function verificacionAcl(){
		return true;
	}

	public function proveedorAction() {
		//$res = Proveedor::listado_select();
		//print_r($res);
		//$res = Concepto::listado_select();
		//print_r($res);
		$res = Formapago::listado_select();
		print_r($res);
		die();
	}
	
}